commit e35ada6dc21d111ac30c30e8b9d792fbca55c9b4
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Nov 2 14:34:25 2025 +0000

    TLS: log key-exchange group

diff --git a/src/src/exim.h b/src/src/exim.h
index 5b931e9f4..18d1b1f40 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -155,7 +155,8 @@ The driver name is a name of a router/transport/authenticator etc in the
 configuration file.  We also use this for some other short strings, such
 as queue names.
 Also TLS ciphersuite name (no real known limit since the protocols use
-integers, but max seen in reality is 45 octets).
+integers, but max seen so far is 70 octets.  Likely to increase further with
+postquantum methods).
 
 RFC 1413 gives us the 512 limit on IDENT protocol userids.
 */
@@ -168,7 +169,7 @@ RFC 1413 gives us the 512 limit on IDENT protocol userids.
 #define EXIM_HUMANNAME_MAX     256
 #define EXIM_DISPLAYMAIL_MAX  1024
 #define EXIM_DRIVERNAME_MAX     64
-#define EXIM_CIPHERNAME_MAX     64
+#define EXIM_CIPHERNAME_MAX    128
 #define EXIM_IDENTUSER_MAX     512
 
 
diff --git a/src/src/tls-gnu.c b/src/src/tls-gnu.c
index 154d3be38..f63d2ee12 100644
--- a/src/src/tls-gnu.c
+++ b/src/src/tls-gnu.c
@@ -57,11 +57,6 @@ require current GnuTLS, then we'll drop support for the ancient libraries).
 #if GNUTLS_VERSION_NUMBER >= 0x030000
 # define SUPPORT_SELFSIGN	/* Uncertain what version is first usable but 2.12.23 is not */
 #endif
-#if GNUTLS_VERSION_NUMBER >= 0x030306
-# define SUPPORT_CA_DIR
-#else
-# undef  SUPPORT_CA_DIR
-#endif
 #if GNUTLS_VERSION_NUMBER >= 0x030014
 # define SUPPORT_SYSDEFAULT_CABUNDLE
 #endif
@@ -78,6 +73,11 @@ require current GnuTLS, then we'll drop support for the ancient libraries).
 # define GNUTLS_AUTO_GLOBAL_INIT
 # define GNUTLS_AUTO_PKCS11_MANUAL
 #endif
+#if GNUTLS_VERSION_NUMBER >= 0x030306
+# define SUPPORT_CA_DIR
+#else
+# undef  SUPPORT_CA_DIR
+#endif
 #if (GNUTLS_VERSION_NUMBER >= 0x030404) \
   || (GNUTLS_VERSION_NUMBER >= 0x030311) && (GNUTLS_VERSION_NUMBER & 0xffff00 == 0x030300)
 # ifndef DISABLE_OCSP
@@ -90,6 +90,9 @@ require current GnuTLS, then we'll drop support for the ancient libraries).
 #if GNUTLS_VERSION_NUMBER >= 0x030506 && !defined(DISABLE_OCSP)
 # define SUPPORT_SRV_OCSP_STACK
 #endif
+#if GNUTLS_VERSION_NUMBER >= 0x030600
+# define EXIM_TLS_KEX_GROUP
+#endif
 #if GNUTLS_VERSION_NUMBER >= 0x030603
 # define EXIM_HAVE_TLS1_3
 # define SUPPORT_GNUTLS_EXT_RAW_PARSE
@@ -2385,11 +2388,15 @@ kx =
 old_pool = store_pool;
   {
   tls_support * tlsp = state->tlsp;
+  gstring * g = NULL;
+#ifdef EXIM_TLS_KEX_GROUP
+  const char * kex_gp = gnutls_group_get_name(gnutls_group_get(session));
+#endif
+
   store_pool = POOL_PERM;
 
 #ifdef SUPPORT_GNUTLS_SESS_DESC
     {
-    gstring * g = NULL;
     uschar * s = US gnutls_session_get_desc(session), c;
 
     if (!s)
@@ -2424,15 +2431,25 @@ old_pool = store_pool;
       if ((c = *s) && *++s == '-') g = string_catn(g, US"__", 2);
       /* now on _ between groups */
       }
-    g = string_catn(g, US":", 1);
-    g = string_cat(g, string_sprintf("%d", (int) gnutls_cipher_get_key_size(cipher) * 8));
+    g = string_fmt_append(g, ":%d", 
+		      (int) gnutls_cipher_get_key_size(cipher) * 8);
+
+# ifdef EXIM_TLS_KEX_GROUP
+    if (kex_gp)
+      g = string_fmt_append(g, ":%s", kex_gp);
+# endif
     state->ciphersuite = string_from_gstring(g);
     }
 #else
-  state->ciphersuite = string_sprintf("%s:%s:%d",
-      gnutls_protocol_get_name(protocol),
-      gnutls_cipher_suite_get_name(kx, cipher, mac),
-      (int) gnutls_cipher_get_key_size(cipher) * 8);
+  g = string_fmt_append(NULL, "%s:%s:%d",
+			gnutls_protocol_get_name(protocol),
+			gnutls_cipher_suite_get_name(kx, cipher, mac),
+			(int) gnutls_cipher_get_key_size(cipher) * 8);
+# ifdef EXIM_TLS_KEX_GROUP
+  if (kex_gp)
+    g = string_fmt_append(g, ":%s", kex_gp);
+# endif
+  state->ciphersuite = string_from_gstring(g);
 
   /* I don't see a way that spaces could occur, in the current GnuTLS
   code base, but it was a concern in the old code and perhaps older GnuTLS
@@ -2441,7 +2458,7 @@ old_pool = store_pool;
   for (uschar * p = state->ciphersuite; *p; p++) if (isspace(*p)) *p = '-';
   tlsp->ver = string_copyn(state->ciphersuite,
 			Ustrchr(state->ciphersuite, ':') - state->ciphersuite);
-#endif
+#endif /*SUPPORT_GNUTLS_SESS_DESC*/
 
 /* debug_printf("peer_status: ciphersuite %s\n", state->ciphersuite); */
 
diff --git a/src/src/tls-openssl.c b/src/src/tls-openssl.c
index ddc72bfa2..eea1f15d3 100644
--- a/src/src/tls-openssl.c
+++ b/src/src/tls-openssl.c
@@ -86,6 +86,9 @@ change this guard and punt the issue for a while longer. */
 # if OPENSSL_VERSION_NUMBER >= 0x010101000L
 #  define EXIM_TLS_EARLY_BANNER
 # endif
+# if OPENSSL_VERSION_NUMBER >= 0x030200000L
+#  define EXIM_TLS_KEX_GROUP
+# endif
 # if OPENSSL_VERSION_NUMBER <  0x030200020L
 #  define EXIM_OPENSSL_BOGUS_SERVER_ALPN	/*XXX when was this fixed? */
 # endif
@@ -3070,8 +3073,11 @@ return OK;
 *************************************************/
 
 /*
-Argument:   pointer to an SSL structure for the connection
-	    pointer to number of bits for cipher
+Arguments:
+  ssl	pointer to an SSL structure for the connection
+  ver	TLS version string
+  bits	pointer for return of number of bits for cipher
+
 Returns:    pointer to allocated string in perm-pool
 */
 
@@ -3089,7 +3095,15 @@ uschar * s;
 SSL_CIPHER_get_bits(c, bits);
 
 store_pool = POOL_PERM;
-s = string_sprintf("%s:%s:%u", ver, SSL_CIPHER_get_name(c), *bits);
+  {
+#ifdef EXIM_TLS_KEX_GROUP
+  const char * cs = SSL_get0_group_name(ssl);
+  if (cs)
+    s = string_sprintf("%s:%s:%u:%s", ver, SSL_CIPHER_get_name(c), *bits, cs);
+  else
+#endif
+    s = string_sprintf("%s:%s:%u", ver, SSL_CIPHER_get_name(c), *bits);
+  }
 store_pool = pool;
 DEBUG(D_tls) debug_printf("Cipher: %s\n", s);
 return s;

